#version 330

uniform sampler2D texRight, texLeft, texTop, texBottom,
				texFront, texBack; 

in vec3 normalV;
in vec3 eyeV;
in vec3 posV;

out vec4 outColor;

void main() {

	// normalize vectors
	vec3 n = normalize(normalV);
	vec3 e = normalize(eyeV);

	// compute reflection vector
	vec3 t = reflect(e, n);

	vec3 dir = t;// + posV;
	
	vec3 absDir = abs(dir);
	
	if (max(absDir.x, max(absDir.y, absDir.z)) == absDir.x) {
		dir = dir/absDir.x;
		if (dir.x >= 0)
			outColor = texture(texRight, -dir.zy * 0.5 + 0.5);
		else
			outColor = texture(texLeft, vec2(dir.z, -dir.y) * 0.5 + 0.5);
	}
	else if (max(absDir.y, absDir.z) == absDir.y) {
		dir = dir/absDir.y;
		if (dir.y >= 0)
			outColor = texture(texTop, dir.xz * 0.5 + 0.5);
		else
			outColor = texture(texBottom, vec2(dir.x, -dir.z) * 0.5 + 0.5);
	}
	else {
		dir = dir/absDir.z;
		if (dir.z >= 0)
			outColor = texture(texFront, vec2(dir.x, -dir.y) * 0.5 + 0.5);
		else
			outColor = texture(texBack, -dir.xy * 0.5 + 0.5);
	}
}