#version 330

uniform samplerCube texUnit; 
uniform float alpha;
uniform int dotModulation;

in vec3 normalV;
in vec3 eyeV;

out vec4 outColor;

void main() {

	// normalize vectors
	vec3 n = normalize(normalV);
	vec3 e = normalize(eyeV);

	// compute reflection vector
	vec3 t = reflect(e, n);

	// access cube map texture
	vec3 ref = texture(texUnit, t).rgb;

	if (dotModulation != 0) {
		float opacity = 1 - dot(-e,n);
		outColor = vec4(ref, opacity);
	}
	else
		outColor = vec4(ref, alpha);
}